/*
 * Scorched Earth 2000
 *
 * Copyright 2004 Mikhail Kruk
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * $Header: /cvsroot/scorch/src/src/scorch/gui/UsernameValidator.java,v 1.1 2004/12/12 05:57:55 meshko Exp $
 *
 * Validate usernames for LoginWindows and NewUserWindow
 */

package scorch.gui;

import java.awt.*;
import java.awt.event.*;

import scorch.*;
import swindows.*;

public class UsernameValidator
{
	public static boolean isUsernameValid(String username, 
		Container owner, Container peer)
	{
		if( username.equals("") )
	    {
			String b[] = {"OK"};
			MessageBox msg = new MessageBox
			    ("Error", "You must provide a user name",
			     b, null, owner, peer);
			msg.display();
			return false;
	    }

		char fchar = username.charAt(0);
		char lchar = username.charAt(username.length()-1);
		if ( fchar < '!' || fchar > '~' || lchar < '!' || lchar > '~' )
	    {
			String b[] = {"OK"};
			MessageBox msg = new MessageBox
			    ("Error", "Username must begin and end with printable characters",
			     b, null, owner, peer);
			msg.display();
			return false;
	    }
	
		if ( username.equals(Protocol.guest) )
		{
			String b[] = {"OK"};
			MessageBox msg = new MessageBox("Error", 
				"Username \""+Protocol.guest+"\" is reserved",
				b, null, owner, peer);
			msg.display();
			return false;
		}

		if (username.length() > 20)
		{
			String b[] = {"OK"};
			MessageBox msg = new MessageBox("Error", 
				"Username can not be longer than 20 characters",
				b, null, owner, peer);
			msg.display();
			return false;
		}
		
		return true;
    }
}
